module ErrorHandling where



data ErrorHandling x = ErrorHandling (String -> Either String x)

instance Monad ErrorHandling where
	return = ErrorHandling . const . Right
	fail x = ErrorHandling (\loc -> Left (loc ++ x))
	a >>= fb = ErrorHandling (\loc ->
		case a of
			ErrorHandling f -> case f loc of
				Left s -> Left s
				Right x -> case fb x of
					ErrorHandling f -> f loc
		)



errorLoc :: String -> ErrorHandling x -> ErrorHandling x
errorLoc newLoc (ErrorHandling f) = ErrorHandling (\loc -> f (loc ++ newLoc ++ "\n"))

getErrorLoc :: ErrorHandling String
getErrorLoc = ErrorHandling Right



runErrorHandling :: ErrorHandling a -> Either String a
runErrorHandling (ErrorHandling f) = f ""

embedErrorHandling :: Monad m => ErrorHandling a -> m a
embedErrorHandling e = case runErrorHandling e of
	Left s -> fail s
	Right x -> return x